[inherit('pJSON')]
program Test(input, output);

const
   JSON = '[ { "no" : 1, "name" : "Alan A", "role" : "Manager" }, ' +
            '{ "no" : 2, "name" : "Brian B", "role" : "Engineer" }, ' +
            '{ "no" : 3, "name" : "Chris C", "role" : "Sales rep" } ]';




var
   employees, employee, newemployee : cJSON_ptr;
   i, no : integer;
   s, name, role : pstr;

begin
   (* iterate over all employees *)
   employees := pJSON_Parse(JSON);
   for i := 0 to pJSON_GetArraySize(employees) - 1 do begin
      employee := pJSON_GetArrayItem(employees, i);
      (* find no, name and role *)
      no := pJSON_IntValue(pJSON_GetObjectItem(employee, 'no'));
      name := pJSON_StringValue(pJSON_GetObjectItem(employee, 'name'));
      role := pJSON_StringValue(pJSON_GetObjectItem(employee, 'role'));
      (* print *)
      writeln('no = ', no:1);
      writeln('name = ', name);
      writeln('role = ', role);
   end;
   (* add employee *)
   newemployee := pJSON_CreateObject;
   pJSON_AddItemToObject(newemployee, 'no',  pJSON_CreateNumber(4));
   pJSON_AddItemToObject(newemployee, 'name',  pJSON_CreateString('Dave D'));
   pJSON_AddItemToObject(newemployee, 'role',  pJSON_CreateString('Intern'));
   pJSON_AddItemReferenceToArray(employees, newemployee);
   (* write out *)
   s := pJSON_PrintUnformatted(employees);
   writeln(s);
   (* *)
   pJSON_Delete(employees);
end.
